//
//  EnxCallKit.swift
//  Enx_CallKit_iOS
//
//  Created by jaykumar on 26/05/22.
//

import UIKit
import Foundation


open class EnxCallKit: NSObject {
    var enxManager = EnxGlobalManager.enxGlobalManager
    private var enxproViderDelegate : EnxProviderDelegates?
    @objc
    public  init(_ delegates :EnxCallStateDelegate?){
        super.init()
        enxManager.setUpCallManager()
        enxproViderDelegate = EnxProviderDelegates(callManager: enxManager.getCallManager(),delegates: delegates)
    }
    
    @objc public func reportIncomingCall(uuid : UUID, callerName : String, hasVideo : Bool, completion: ((NSError?) -> Void)? = nil){
            enxManager.setUUID(uuid: uuid)
            enxManager.setCallerName(callerName: callerName)
            enxManager.setHasVideo(hasVideo: hasVideo)
            enxproViderDelegate?.reportIncomingCalls(uuid: enxManager.getUUID()!, handle: enxManager.getCallerName(), hasVideo: enxManager.getHasVideo(), completion: completion)
    }
    @objc public func endCall(){
        enxproViderDelegate?.reportEndCall()
    }
}
